<template>
  <a-card :bordered="false" :class="'cust-erp-sub-tab'">
    <!-- 查询区域 -->
    <div class="table-page-search-wrapper">
      <a-form layout="inline" @keyup.enter.native="searchQuery">
        <a-row :gutter="24">
        </a-row>
      </a-form>
    </div>
    <!-- 查询区域-END -->
    <!-- 操作按钮区域 -->
    <div class="table-operator" v-if="mainId">
      <!-- <a-button @click="handleAdd" type="primary" icon="plus">新增</a-button> -->
      <!-- <a-button type="primary" icon="download" @click="handleExportXls('工艺参数')">导出</a-button>
      <a-upload
        name="file"
        :showUploadList="false"
        :multiple="false"
        :headers="tokenHeader"
        :action="importExcelUrl"
        @change="handleImportExcel">
          <a-button type="primary" icon="import">导入</a-button>
      </a-upload> -->
      <a-dropdown v-if="selectedRowKeys.length > 0" v-has="'accountSons:add&edit&delete&submit'">
        <a-menu slot="overlay">
          <a-menu-item key="1" @click="batchDel"><a-icon type="delete"/>删除</a-menu-item>
          <!-- <a-menu-item key="1" @click="handleSubmitBatch"><a-icon type="to-top" />提交</a-menu-item> -->
        </a-menu>
        <a-button style="margin-left: 8px"> 批量操作 <a-icon type="down" /></a-button>
      </a-dropdown>
    </div>

    <!-- table区域-begin -->
    <div>
      <div class="ant-alert ant-alert-info" style="margin-bottom: 16px;">
        <i class="anticon anticon-info-circle ant-alert-icon"></i> 已选择 <a style="font-weight: 600">{{ selectedRowKeys.length }}</a>项
        <a style="margin-left: 24px" @click="onClearSelected">清空</a>
      </div>
      <a-table
        ref="table"
        size="middle"
        bordered
        rowKey="id"
        :scroll="{x:true}"
        :columns="columns"
        :dataSource="dataSource"
        :pagination="ipagination"
        :loading="loading"
        :rowSelection="{selectedRowKeys: selectedRowKeys, onChange: onSelectChange}"
        @change="handleTableChange">
        <!-- <template
          v-for="col in columns"
          :slot="col.dataIndex"
          slot-scope='text, record, index'
        >
          <div :key="col.dataIndex">
            <span v-if="col.dataIndex == 'remark'">
              <j-ellipsis
                :value="text"
                :length="10"
              />
            </span>
            <a-input-number
              :value="text"
              v-if="col.dataIndex == 'parametersValue'"
              @change="(e)=>handleChange(e, record.key, col, index)"
              style="width: 100%"
              :disabled="!isOpen"
              title="开启工艺参数管理后可填写"
            />
            <span v-if="col.dataIndex == 'action'">
              <a-button
                type="primary"
                @click="handleEdit(record)"
                v-has="'accountSons:add&edit&delete&submit'"
                :disabled="!isOpen"
                title="开启工艺参数管理后可点击"
              >提交</a-button>
            </span>
          </div>
        </template> -->
        <!-- <span slot="action" slot-scope="text, record">
          <a @click="handleEdit(record)">编辑</a>
          <a-divider type="vertical" />
          <a-popconfirm title="确定删除吗?" @confirm="() => handleDelete(record.id)">
            <a>删除</a>
          </a-popconfirm>
        </span> -->
      </a-table>
    </div>
    <equipmentProcessParameters-modal ref="modalForm" @ok="modalFormOk" :mainId="mainId"></equipmentProcessParameters-modal>
  </a-card>
</template>

<script>

  import { JeecgListMixin } from '@/mixins/JeecgListMixin'
  import EquipmentProcessParametersModal from './EquipmentProcessParametersModal'
import { postAction,putAction } from '../../../../api/manage'

  export default {
    name: "EquipmentProcessParametersList",
    mixins:[JeecgListMixin],
    components: { EquipmentProcessParametersModal },
    props:{
      mainId:{
        type:String,
        default:'',
        required:false
      },
      isOpen:{
        type:Boolean,
        default:true,
        required:false
      }
    },
    watch:{
      mainId:{
        immediate: true,
        handler(val) {
          if(!this.mainId){
            this.clearList()
          }else{
            this.queryParam['equipmentId'] = val
            this.loadData(1);
          }
        }
      }
    },
    data () {
      return {
        description: '设备台账管理页面',
        disableMixinCreated:true,
        // 表头
        columns: [
        {
          title: '#',
          dataIndex: '',
          key: 'rowIndex',
          width: 60,
          align: "center",
          customRender: function (t, r, index) {
            return parseInt(index) + 1;
          }
        },
        {
          title: '工艺参数编码',
          align: "center",
          dataIndex: 'processParametersNum',
          // width:350,
        },
        {
          title: '工艺参数名称',
          align: "center",
          dataIndex: 'processParametersName',
          // width:350,
        },
        {
          title: '计量单位',
          align: "center",
          dataIndex: 'processParametersUnitName',
          // width:350,
        },
        {
          title: '参数值',
          align: "center",
          dataIndex: 'parametersValue',
          // scopedSlots: {
          //   customRender: 'parametersValue'
          // },
          // width:350,
        },
        {
          title: '备注',
          align: "center",
          dataIndex: 'remark',
          // scopedSlots: {
          //   customRender: 'remark'
          // },
        },
        // {
        //   title: '操作',
        //   align: "center",
        //   dataIndex: 'action',
        //   scopedSlots: {
        //     customRender: 'action'
        //   },
        //   width:200,
        //   fixed: 'right',
        // },
        ],
        url: {
          list: "/eam/equipmentProcessParameters/list",
          edit: "/eam/equipmentProcessParameters/edit",
          submitBatch:"/eam/equipmentProcessParameters/submitBatch",
          // delete: "/new/equipment/deleteEquipmentProcessParameters",
          // deleteBatch: "/new/equipment/deleteBatchEquipmentProcessParameters",
          // exportXlsUrl: "/new/equipment/exportEquipmentProcessParameters",
          // importUrl: "/new/equipment/importEquipmentProcessParameters",
        },
        dictOptions:{
        }
      }
    },
    created() {
    },
    computed: {
      importExcelUrl(){
        return `${window._CONFIG['domianURL']}/${this.url.importUrl}/${this.mainId}`;
      }
    },
    methods: {
      clearList(){
        this.dataSource=[]
        this.selectionRows = []
        this.selectedRowKeys=[]
        this.ipagination.current = 1
      },
      handleEdit(record) {
      this.loading = true;
      if (record.parametersValue === "" || record.parametersValue === null) {
        this.$message.warning("参考值不能为空！")
        this.loading = false;
        return
      }
      postAction(this.url.edit, record).then((res) => {
        if (res.success) {
          this.$message.success(res.message);
          this.loadData()
        } else {
          this.$message.warning(res.message);
        }
      }).finally(() => {
        this.loading = false;
      });
    },
    handleChange(value, key, column, index) {
      let that = this;
      const temp = [...that.dataSource];
      const target = temp.filter(item => key === item.key)[index];
      if (target) {
        target[column.dataIndex] = value;
        if ('parametersValue' == column.dataIndex) {
          target['parametersValue'] = value;
        }
        //显示带过来的数据
        that.dataSource = temp;
      }
    },
    handleSubmitBatch(){
          for(var i=0;i<this.selectionRows.length;i++){
            let parametersValue = this.selectionRows[i].parametersValue;
            if(parametersValue==null||parametersValue==undefined||parametersValue==''){
              this.$message.warning("请先填写选择项的参数值再提交")
              return false;
            }
          }
        let that = this;
        this.$confirm({
        title: '设备精度确认提交！',
        content: '确认提交吗！',
        okText: '确认',
        cancelText: '取消',
        onOk() {
         that.loading=true;
         putAction(that.url.submitBatch,that.selectionRows).then((res) => {
            if (res.success) {
              that.$message.success("提交成功！")
              that.loadData(1)
            } else {
              that.$message.warning("提交失败！")
            }
          }).finally(() => {
            that.loading = false;
            that.clearList();
          })
        },
      })
    },
    onSelectChange(selectedRowKeys, selectionRows) {
        this.selectedRowKeys = selectedRowKeys;
        this.selectionRows = selectionRows;
    },


    },
    mounted(){
      this.$bus.$on('loadData', (data) => {
            this.loadData();
      });
    }
  }
</script>
<style scoped>
  @import '~@assets/less/common.less'
</style>
